package vip.xumy.core.conf;

import java.util.Collections;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.cors.CorsConfiguration;
import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
import org.springframework.web.filter.CorsFilter;

/**
 * Ownership belongs to the company
 *
 * @author:mengyxu
 * @date:2022年9月29日
 */

@Configuration
public class BaseConfiger {

	/**
	 * 允许跨域请求
	 * 
	 * @return
	 */
	@Bean
	public CorsFilter corsFilter() {
		CorsConfiguration corsConfiguration = new CorsConfiguration();
		// 1,允许任何来源
		corsConfiguration.setAllowedOriginPatterns(Collections.singletonList("*"));
		// 2,允许任何请求头
		corsConfiguration.addAllowedHeader(CorsConfiguration.ALL);
		// 3,允许任何方法
		corsConfiguration.addAllowedMethod(CorsConfiguration.ALL);
		// 4,允许凭证
		corsConfiguration.setAllowCredentials(true);

		UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
		source.registerCorsConfiguration("/**", corsConfiguration);
		return new CorsFilter(source);
	}

}
