package vip.xumy.core.http;

import java.util.Map;

import lombok.Getter;
import lombok.Setter;

/**
 * Ownership belongs to the company author:mengyxu date:2019年5月25日
 */

@Setter
@Getter
public class HttpResult {

	// 响应的状态码
	private int code;

	// 响应的响应体
	private String body;

	private Map<String, String> cookies;

	private String contentType;

	public HttpResult() {
		super();
	}

	public HttpResult(int code, String body) {
		super();
		this.code = code;
		this.body = body;
	}

	public HttpResult(int code, String body, String contentType) {
		super();
		this.code = code;
		this.body = body;
		this.contentType = contentType;
	}

	public boolean isJson() {
		return "application/json".equals(contentType);
	}

}
