package vip.xumy.core.pojo.com;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Getter;

@Getter
@Schema(description = "返回消息通用格式")
public class BaseResponse {
	@Schema(description = "请求是否成功")
	private boolean success;
	@Schema(description = "结果提示信息")
	private String message;
	@Schema(description = "具体数据")
	private Object data;
	
	public <T> BaseResponse(T data) {
		this.success = true;
		this.data = data;
	}

	public BaseResponse(boolean success, String message) {
		this.success = success;
		this.message = message;
	}
	
	public BaseResponse() {
		super();
		this.success = true;
	}
	
}
