package vip.xumy.core.test;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

import org.junit.jupiter.api.Test;

import vip.xumy.core.utils.FileUtil;

/**
 * Ownership belongs to the company
 *
 * @author:mengyxu
 * @date:2023年3月20日
 */

public class ExcelUtilTester {

	@Test
	public void readRowTester() {
		String excelPath = "E:\\download\\ok_geo.csv\\ok_geo.csv";
		String table = "geographic_area";
		String sqlPath = "E:\\download\\ok_geo.csv\\ok_geo.sql";
		File newFile = new File(sqlPath);
		File parent = newFile.getParentFile();
		if (!parent.exists()) {
			parent.mkdirs();
		}
		try (BufferedWriter writer = new BufferedWriter(new FileWriter(newFile));
				Scanner scanner = FileUtil.scannerFile(excelPath);) {
			while (scanner.hasNextLine()) {
				String[] content = scanner.nextLine().split("\",\"");
				if (content == null || content.length < 4) {
					continue;
				}
				String[] arr = content[0].split(",");
				StringBuilder sb = new StringBuilder();
				sb.append("INSERT INTO ").append(table).append(" VALUES ( ");
				for (int i = 0; i < 3; i++) {
					sb.append(arr[i]).append(",");
				}
				sb.append(arr[3]).append("\",\"");

				sb.append(content[1]).append("\",");
				String center = content[2];
				if ("EMPTY".equals(center)) {
					sb.append("NULL,");
				} else {
					sb.append("GeomFromText('POINT (").append(center).append(")',0),");
				}
				String area = content[3];
				if ("EMPTY\"".equals(area)) {
					sb.append("NULL);");
				} else {
					sb.append("GeomFromText('POLYGON ((").append(area.substring(0, area.length() - 1));
					int i = area.indexOf(",");
					sb.append(",").append(area.substring(0, i)).append("))',0));");
				}
				writer.write(sb.toString(), 0, sb.length());
				writer.newLine();
			}
			scanner.close();
			writer.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
